"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.generateIco = void 0;
var tslib_1 = require("tslib");
var generateIco_1 = require("./generateIco");
var parsePng_1 = require("./parsePng");
var resizePng_1 = require("./resizePng");
var defaultSizes = [16, 24, 32, 48, 64, 128, 256];
function generateIco(imageBuffers, options) {
    if (options === void 0) { options = {}; }
    return tslib_1.__awaiter(this, void 0, void 0, function () {
        var images, opts;
        return tslib_1.__generator(this, function (_a) {
            if (Array.isArray(imageBuffers)) {
                images = imageBuffers;
            }
            else {
                images = [imageBuffers];
            }
            opts = tslib_1.__assign({ resize: false, sizes: defaultSizes }, options);
            if (opts.resize) {
                return [2, (0, resizePng_1.resizeLargestPng)(images, opts.sizes)
                        .then(parsePng_1.parseAllBuffersToPngs)
                        .then(generateIco_1.generateIcoFromPNGs)];
            }
            return [2, (0, parsePng_1.parseAllBuffersToPngs)(images).then(generateIco_1.generateIcoFromPNGs)];
        });
    });
}
exports.generateIco = generateIco;
exports.default = generateIco;
//# sourceMappingURL=index.js.map