"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.parseAllBuffersToPngs = exports.parseBufferToPng = void 0;
var tslib_1 = require("tslib");
var pngjs_1 = require("pngjs");
function parseBufferToPng(buffer, options) {
    return tslib_1.__awaiter(this, void 0, void 0, function () {
        return tslib_1.__generator(this, function (_a) {
            return [2, new Promise(function (resolve, reject) {
                    var image = new pngjs_1.PNG(options);
                    var pngMetadata;
                    image.on('metadata', function (metadata) {
                        pngMetadata = metadata;
                    });
                    image.parse(buffer, function (err, data) {
                        if (err == null) {
                            resolve({
                                image: image,
                                metadata: pngMetadata,
                            });
                        }
                        else {
                            reject(err);
                        }
                    });
                })];
        });
    });
}
exports.parseBufferToPng = parseBufferToPng;
function parseAllBuffersToPngs(buffers, options) {
    return tslib_1.__awaiter(this, void 0, void 0, function () {
        var _this = this;
        return tslib_1.__generator(this, function (_a) {
            return [2, Promise.all(buffers.map(function (b) { return tslib_1.__awaiter(_this, void 0, void 0, function () { return tslib_1.__generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4, parseBufferToPng(b, options)];
                        case 1: return [2, _a.sent()];
                    }
                }); }); }))];
        });
    });
}
exports.parseAllBuffersToPngs = parseAllBuffersToPngs;
//# sourceMappingURL=parsePng.js.map