"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.resizeLargestPng = exports.resizePng = void 0;
var tslib_1 = require("tslib");
var image_size_1 = tslib_1.__importDefault(require("image-size"));
var jimp = tslib_1.__importStar(require("jimp"));
function resizePng(imageBuffer, options) {
    return tslib_1.__awaiter(this, void 0, void 0, function () {
        var image;
        return tslib_1.__generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4, jimp.read(imageBuffer)];
                case 1:
                    image = _a.sent();
                    if (typeof options.width !== 'number') {
                        options.width = Math.trunc(image.bitmap.width * (options.height / image.bitmap.height));
                    }
                    if (typeof options.height !== 'number') {
                        options.height = Math.trunc(image.bitmap.height * (options.width / image.bitmap.width));
                    }
                    return [2, image
                            .resize(options.width, options.height)
                            .getBufferAsync(jimp.MIME_PNG)];
            }
        });
    });
}
exports.resizePng = resizePng;
function resizeLargestPng(images, imageSizes) {
    return tslib_1.__awaiter(this, void 0, void 0, function () {
        var largestImage;
        return tslib_1.__generator(this, function (_a) {
            largestImage = images
                .map(function (i) {
                var _a = (0, image_size_1.default)(i), width = _a.width, height = _a.height;
                return {
                    image: i,
                    width: width,
                    height: height,
                };
            })
                .reduce(function (a, b) {
                if (typeof a.width !== 'number') {
                    return b;
                }
                if (typeof b.width !== 'number') {
                    return a;
                }
                if (a.width > b.width) {
                    return a;
                }
                else {
                    return b;
                }
            }, { width: 0, height: 0, image: Buffer.alloc(0) });
            return [2, Promise.all(imageSizes
                    .filter(function (s) { return s <= largestImage.width; })
                    .map(function (targetSize) {
                    return resizePng(largestImage.image, {
                        width: targetSize,
                        height: targetSize,
                    });
                }))];
        });
    });
}
exports.resizeLargestPng = resizeLargestPng;
//# sourceMappingURL=resizePng.js.map