import { __assign, __awaiter, __generator } from "tslib";
import { generateIcoFromPNGs } from './generateIco';
import { parseAllBuffersToPngs } from './parsePng';
import { resizeLargestPng } from './resizePng';
var defaultSizes = [16, 24, 32, 48, 64, 128, 256];
export function generateIco(imageBuffers, options) {
    if (options === void 0) { options = {}; }
    return __awaiter(this, void 0, void 0, function () {
        var images, opts;
        return __generator(this, function (_a) {
            if (Array.isArray(imageBuffers)) {
                images = imageBuffers;
            }
            else {
                images = [imageBuffers];
            }
            opts = __assign({ resize: false, sizes: defaultSizes }, options);
            if (opts.resize) {
                return [2, resizeLargestPng(images, opts.sizes)
                        .then(parseAllBuffersToPngs)
                        .then(generateIcoFromPNGs)];
            }
            return [2, parseAllBuffersToPngs(images).then(generateIcoFromPNGs)];
        });
    });
}
export default generateIco;
//# sourceMappingURL=index.js.map